function test_roundoff_dither
%TEST_ROUNDOFF_DITHER  Test application of dither

clear;

Q3=qstruct('Name','Q3','B',7,'di','on','tod','sin','A',1,'ph',5,'rof',[4,3],'sequenceperm','en');
qstructget(Q3);
Q3=qstructset(Q3,'dither','off')
qstructget(Q3)
Q3=qstructset(Q3,'ph',3)
qstructget(Q3)
Q3=qstructset(Q3,'dither','on')
qstructget(Q3)
Q3=qstructset(Q3,'ph',4)
qstructget(Q3);
Q3=qstructset(Q3,'dither','on','tod','sin','A',1,'ph',2,'rof',[3,4])
qstructget(Q3);
 
Q4=qstruct('Name','Q4','B',5,'fb',3,'dither','on','tod','user','DFun',[0 1 2 3 4 5 6])
qstructget(Q4);
Q4=qstructset(Q4,'dither','off')
qstructget(Q4);
%Q4=qstructset(Q4,'B',5,'di','on','seq','dis','tod','user','dfun',[0 1 2 6 -2 -3])
qstructget(Q4);
Q4=qstructset(Q4,'tod','Ga','var',1,'seq','en')
qstructget(Q4);

Q5=qstruct('Name','Q5','B',7,'di','on','tod','t2')
qstructget(Q5)
Q5=qstructset(Q5,'dither','off')
qstructget(Q5)
Q5=qstructset(Q5,'L',4)
qstructget(Q5)
Q5=qstructset(Q5,'dither','on')
qstructget(Q5)
Q5=qstructset(Q5,'L',5)
qstructget(Q5)

q=qstruct('name','q','p',6,'dither','on','tod','u2','seq','dis')
qstructget(q)
q=qstructset(q,'tod','triangular','L',5)
qstructget(q)
q=qstructset(q,'dither','off','dfun',[1 2 3 5 6])
qstructget(q)
q=qstructset(q,'dither','on','tod','Ga','Var',2,'seq','en')
qstructget(q)

pause off
roundq('private','dither_teszt');
roundq('private','dither_bar',10)
roundq('private','dither_hist',1000);
pause on
