%TRUNC An example from dissertation of G. Horvath, Dr.

close all;

% 4 bites, fix-pontos kvantl, dither = off
BIT4_d_off = qstruct('Name','BIT4_d_off','type','fixed-point','B',4,'fb',0);
qstructget(BIT4_d_off);

% rdir = trunc
BIT4_d_off_trunc = qstructset(BIT4_d_off,'rdir','trunc');
qstructget(BIT4_d_off_trunc);

clear x1;
clear t1;
fig = 1;

f = 100;
fs = 800;
tt = 1;
A=7;
N=512;
 for i=0:1/fs:1/fs*N-1/fs
     t1(tt)=i;
     tt=tt+1;
 end
 
 for i=1:length(t1)
    arg(i)=2*pi*f*t1(i);
    x1(i)=A*sin(arg(i));
 end
 
%  figure(fig);
%  fig = fig + 1;
%  plot(t1,x1,'x');
%  title('A 100 Hz-es szinuszjel');
 
 for hanyszor = 1:1
 disp(['1. ciklus, ' num2str(hanyszor) '. eset ']);
 
  % FFT: 4 bites fixpontos aritmetika, dither nlkl:
  
 runmod.exponent = 'block-float';
 
 X1_FFT_BIT4_d_off_trunc_results = roundfft(x1,BIT4_d_off_trunc,runmod);
 X1_FFT_BIT4_d_off_trunc(hanyszor,:)=X1_FFT_BIT4_d_off_trunc_results.data*X1_FFT_BIT4_d_off_trunc_results.bfe;
 filename = ['hg_examples_trunc_results_double' num2str(A) 'A_' '.mat'];
 save(filename);
 end
 
 for n=1:N
     osszeg_X1_FFT_BIT4_d_off_trunc(n)=sum(X1_FFT_BIT4_d_off_trunc(1:end,n));
 end
 
fig2=16;
filename = 'hg_examples_trunc_results_double7A_.mat';
load hg_examples_trunc_results_double7A_;

figure(fig2);
fig2 = fig2 + 1;
clear data;
clear data2;
data = 20*log10(abs((osszeg_X1_FFT_BIT4_d_off_trunc)/hanyszor));
for d=1:length(data)
    if (isinf(data(d)))
        data2(d)=-200;
    else
        data2(d)=data(d);
    end
end       

plot((0:floor(length(data2)/2)-1)*fs/N,data2(1:floor(length(data2)/2)));
title(['FFT: 4 bites fixpontos aritmetika, dither nlkl, ' num2str(hanyszor) ' futs tlaga']);
%xlabel(filename);
ylim([-240 160]);
xlim([0 402.12]);  
ylabel('dB');  